#
# spec file for package systemtap (Version 1.0)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           systemtap
BuildRequires:  gcc-c++ glib2-devel libcap-devel libebl-devel pkg-config sqlite-devel
BuildRequires:  mozilla-nspr-devel mozilla-nss-devel mozilla-nss-tools
%define use_snapshot	0
License:        GPLv2+
Version:        1.0
Release:        1.1.1
Summary:        Instrumentation System
Group:          Development/Tools/Debuggers
Url:            http://sourceware.org/systemtap/
# Requires: kernel-source gcc make
# Suggest: kernel-smp-debuginfo
%if %use_snapshot
%define package_version  20090214
%else
%define package_version  %{version}
%endif
Source:         ftp://sources.redhat.com/pub/systemtap/snapshots/systemtap-%{package_version}.tar.bz2
Patch1:         systemtap-docdir-fix.diff
Patch2:         systemtap-ioblock-suse-kernel-fix.diff
Patch3:         systemtap-CVE-2009-2911.diff
Patch4:         systemtap-CVE-2009-4273.diff
Patch5:         systemtap-CVE-2010-0411.diff
Requires:       libebl1
Requires:       %{name}-runtime = %{version}-%{release}
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
SystemTap is an instrumentation system for systems running Linux 2.6.
Developers can write instrumentation to collect data on the operation
of the system.



Authors:
--------
    Frank Ch. Eigler <fche@redhat.com>
    Graydon Hoare <graydon@redhat.com>
    Martin Hunt <hunt@redhat.com>
    Tom Zanussi <zanussi@us.ibm.com>

%package runtime
License:        GPLv2+
Group:          Development/Tools/Debuggers
Summary:        Runtime environment for systemtap

%description runtime
SystemTap is an instrumentation system for systems running Linux 2.6.
This package contains the runtime environment for systemtap programs.



Authors:
--------
    Frank Ch. Eigler <fche@redhat.com>
    Graydon Hoare <graydon@redhat.com>
    Martin Hunt <hunt@redhat.com>
    Tom Zanussi <zanussi@us.ibm.com>

%package client
License:        GPLv2+
Group:          Development/Tools/Debuggers
Summary:        Systemtap client
Requires:       %{name}-runtime = %{version}-%{release}

%description client
SystemTap is an instrumentation system for systems running Linux 2.6.
This package contains the client component for systemtap.



Authors:
--------
    Frank Ch. Eigler <fche@redhat.com>
    Graydon Hoare <graydon@redhat.com>
    Martin Hunt <hunt@redhat.com>
    Tom Zanussi <zanussi@us.ibm.com>

%package server
License:        GPLv2+
Group:          Development/Tools/Debuggers
Summary:        Systemtap server
Requires:       %{name} = %{version}-%{release}

%description server
SystemTap is an instrumentation system for systems running Linux 2.6.
This package contains the server component of systemtap.



Authors:
--------
    Frank Ch. Eigler <fche@redhat.com>
    Graydon Hoare <graydon@redhat.com>
    Martin Hunt <hunt@redhat.com>
    Tom Zanussi <zanussi@us.ibm.com>

%package sdt-devel
License:        GPLv2+
Group:          Development/Tools/Debuggers
Summary:        Static probe support tools
Requires:       %{name} = %{version}-%{release}

%description sdt-devel
SystemTap is an instrumentation system for systems running Linux 2.6.
This package contains the support tools for static probes.



Authors:
--------
    Frank Ch. Eigler <fche@redhat.com>
    Graydon Hoare <graydon@redhat.com>
    Martin Hunt <hunt@redhat.com>
    Tom Zanussi <zanussi@us.ibm.com>

%prep
%if %use_snapshot
%setup -n src -q
%else
%setup -n %{name}-%{package_version} -q
%endif
%patch1 -p1
%patch2
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
autoreconf -fi
%configure
make %{?jobs:-j %jobs}

%install
%if %suse_version < 1030
# workaround for old autoconf
export MKDIR_P="mkdir -p"
%endif
%makeinstall
mkdir -p $RPM_BUILD_ROOT/var/cache/systemtap
# doc subpackage is built separetely
# cp README AUTHORS NEWS COPYING $RPM_BUILD_ROOT%{_docdir}/systemtap/
rm -rf $RPM_BUILD_ROOT%{_docdir}/systemtap
rm -rf $RPM_BUILD_ROOT%{_mandir}/man3

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%{_bindir}/stap
%{_bindir}/stap-env
%{_bindir}/stap-gen-cert
%{_bindir}/stap-authorize-cert
%{_bindir}/stap-authorize-signing-cert
%{_mandir}/man1/*
%{_datadir}/systemtap
%dir %attr(0755,root,root) /var/cache/systemtap

%files runtime
%defattr(-,root,root)
%{_bindir}/staprun
%{_bindir}/stap-report
%{_libexecdir}/systemtap
%{_mandir}/man8/staprun.*

%files client
%defattr(-,root,root)
%{_bindir}/stap-client
%{_bindir}/stap-env
%{_bindir}/stap-find-servers
%{_bindir}/stap-authorize-cert
%{_bindir}/stap-authorize-server-cert
%{_bindir}/stap-client-connect
%{_mandir}/man8/stap-server.8*

%files server
%defattr(-,root,root)
%{_bindir}/stap-server
%{_bindir}/stap-serverd
%{_bindir}/stap-env
%{_bindir}/stap-start-server
%{_bindir}/stap-find-servers
%{_bindir}/stap-find-or-start-server
%{_bindir}/stap-stop-server
%{_bindir}/stap-gen-cert
%{_bindir}/stap-authorize-cert
%{_bindir}/stap-authorize-server-cert
%{_bindir}/stap-server-connect
%{_bindir}/stap-sign-module
%{_mandir}/man8/stap-server.8*

%files sdt-devel
%defattr(-,root,root)
%{_bindir}/dtrace
%{_includedir}/sys/*.h

%changelog
* Tue Feb 23 2010 tonyj@novell.com
- Update to version 1.0 for CVE-2009-4273
- CVE-2009-4273 (bnc#574243) - VUL-0: systemtap-server code exec
- CVE-2010-0411 (bnc#577382) - VUL-1: systemtap: DoS issue in __get_argv() function
- CVE-2009-2911 (bnc#548361) - denial of service issues in 1.0 --unprivileged mode
* Thu Aug 13 2009 tiwai@suse.de
- updated to version 0.9.9:
  * Systemwide kernel .function.return (kretprobe) maxactive overridden
  with -DKRETACTIVE=nnn parameter.
  * performance improvement in translation pass 2
  * new DW_OP_call_frame_CFA handling with elfutils 0.142
  * dwarf probes now show parameters and local variables in the verbose
  listing mode (-L)
  * symbol aliases are now resolved to their canonical dwarf names
  * The syntax for dereferencing $target variables and @cast() gained new
  capabilities
  * For reading all probe variables, kernel.mark now supports $$vars and
  $$parms, and process.syscall now supports $$vars.
  * SNMP tapset for many network statistics
  * dentry tapset to map kernel VFS directory entries to file or full
  path names: d_path(), d_name() and reverse_path_walk().
  * SystemTap now has userspace markers in its own binaries
  * More to see in NEWS
* Tue Jul 21 2009 tiwai@suse.de
- corrected to use libexecdir
- fix summary and description
* Tue Jun 16 2009 tiwai@suse.de
- updated to version 0.9.8:
  * Module signing support
  * Debuginfo suggestions when a script fails
  * Using %%M in print formats for hex dumps can now print entire
    buffers
  * Dwarfless syscalls: The nd_syscalls tapset is now available to
    probe system calls without requiring kernel debug info.
  * sid() returns the session ID of the current process
  * stringat() indexes a single character from a string.
  * New script examples
* Wed May 20 2009 tiwai@suse.de
- split docs and examples to docs subpackage and generate from its
  own spec file to cut off the dependency loop
* Fri May 15 2009 tiwai@suse.de
- split to several subpackages, systemtap-runtime, -client, -server
  and -sdt-devel (bnc#503088).
* Fri May  8 2009 tiwai@suse.de
- updated to released version 0.9.7:
  * Lots of fixes, improvements, see NEWS file for details
* Thu Feb 19 2009 tiwai@suse.de
- updated to systemtap snashot 20090214:
  * Version bump to 0.8
  * Bunch of fixes and updates, see ChangeLog
  * Fix for recent 2.6.29 kernels
- fixed doc build, using fop instead of direct xmlto pdf
* Thu Feb 12 2009 tiwai@suse.de
- backport the blacklist additions from upstream to fix possible
  system crash (bnc#459387, bnc#473277)
* Thu Feb  5 2009 tiwai@suse.de
- Backport tapset/signal.stp to fix the signal probe problem
  (bnc#468321)
* Tue Feb  3 2009 tiwai@suse.de
- Fix debugpath.exp with $SYSTEMTAP_DEBUGINFO_PATH (bnc#471811)
* Thu Jan 29 2009 tiwai@suse.de
- Fix procfs dir_entry count warning (bnc#470526)
- Improve the parsing of lineno checks (bnc#468247)
* Thu Jan 15 2009 tiwai@suse.de
- Fix quoting in Tcl scripts (bnc#461588)
* Mon Jan 12 2009 tiwai@suse.de
- Fix syntax errors with Tcl send_log (bnc#460886)
* Thu Dec 18 2008 tiwai@suse.de
- Fix stap failures with signal tapsets (bnc#459387)
* Tue Dec 16 2008 tiwai@suse.de
- Fix dependency on libebl1 (bnc#448331, #445783)
- Fix stap for 2.6.28 kernels
* Fri Dec 12 2008 tiwai@suse.de
- Don't assert of dwarf_getsrcfiles().  This hits recent SUSE
  kernels (bnc#455992)
- Backport fix patches for stap-*-server scripts to run with
  netcat (bnc#446686)
* Mon Dec  8 2008 tiwai@suse.de
- fixed unresolved path in man pages (bnc#457217)
- fixed build for old distros on OBS
* Thu Dec  4 2008 tiwai@suse.de
- fix ioblock.stp for SUSE 2.6.27.x kernel (bnc#456175)
* Fri Nov 21 2008 tiwai@suse.de
- Add the bound check of parameters to fix segfault (bnc#447551)
* Tue Nov  4 2008 tiwai@suse.de
- Fix systemtap assertion with CONFIG_RELOCATABLE (bnc#440351)
* Thu Sep 11 2008 tiwai@suse.de
- updated to snapshot 20080906
  * Fix / clean up autotools stuff
  * Ugly workaround for 2.6.27 and later kernel
  * stap-server updates
  * Lots of small fixes
* Tue Aug 12 2008 tiwai@suse.de
- updated to snapshot 20080809
  * bump to 0.7.1
  * tutorials
  * examples
  * i386-fix merged
  * previous patches are all merged in
- add latex2html to buildrequires for generating documents
* Fri Jun 20 2008 tiwai@suse.de
- fix run on i386 (bnc#401970)
- don't include obsolete linux/compile.h.
* Wed Jun 18 2008 tiwai@suse.de
- updated to snapshot 20080614:
  * bump to version 0.7, man page updates, misc fixes
    see ChangeLog for details
* Fri Mar 14 2008 tiwai@suse.de
- updated to snapshot 20080308:
  * configure fixes, compile option changes
  * fixes for 2.6.25 kernel
* Wed Jan 30 2008 tiwai@suse.de
- updated to snapshot 20080126
  * fix configure and automake stuff
  * gcc 4.3 fix is included
  * ufprobes fixes, improvements
  * reorganized probe condition implementation.
* Fri Jan 11 2008 tiwai@suse.de
- updated to snapshot 20080105
- fixed build of the snapshot with gcc 4.3
* Mon Nov 19 2007 tiwai@suse.de
- enable gcc-4.3 patch (yes, we use only gcc4.3 now)
- updated to snapshot 20071117
* Thu Oct 25 2007 tiwai@suse.de
- disable gcc-4.3 fix again since it breaks older gccs...
* Wed Oct 24 2007 tiwai@suse.de
- fix build with gcc 4.3
* Mon Oct 22 2007 tiwai@suse.de
- updated to snapshot 20071020:
  * bump up version 0.6
  * bunch of updates and fixes, see ChangeLog
* Tue Aug 14 2007 tiwai@suse.de
- updated to snapshot 20070811:
  * Updated -m MODNAME usage
  * Rework on line editing functions
* Mon Jul 16 2007 tiwai@suse.de
- updated to snapshot 20070714:
  * configure fix for sqlite
  * support for crash extension module
  * new enum for type column in coverage_element
* Wed Jul  4 2007 tiwai@suse.de
- updated to snapshot 20070630:
  * auto-tools fixes, sqlite3 requirement
- add sqlite-devel and glib2-devel to buildrequires
* Wed Jun  6 2007 tiwai@suse.de
- updated to snapshot 20070602:
  * fix for gcc4.3
  * minor fixes in elaborate.*
- include the snapshot date into version string
- clean up spec file
* Tue May 22 2007 tiwai@suse.de
- updated to snapshot 20070519:
  * Updated temporary handlings
  * Autoconf tweaks
  * Performance improvements with const and temporary handlings
  * Removed do_write and do_read probles, added aio_write,
    aio_read, writev and readv probes.
* Mon May 21 2007 tiwai@suse.de
- use the external elfutils packages.
* Tue Apr 24 2007 tiwai@suse.de
- updated to snapshot 20070421 and elfutils-0.127:
  * minor compile warning fixes
  * add interruptible parameter
  * improvement on documents
  * fix for debugfs and relayfs mounts
  * see ChangeLog for other changes
* Mon Mar 19 2007 tiwai@suse.de
- updated to snapshot 20070317:
  including all fix patches
* Thu Mar  8 2007 tiwai@suse.de
- fix the handling of function arguments in more generic way
  (#245310, #252311)
  added a new option -P to switch the prologue-search behavior
* Wed Mar  7 2007 tiwai@suse.de
- fix misalignment of exception table entry on s390x (#249576)
* Mon Feb 26 2007 tiwai@suse.de
- fix crash with large H value in hist_linear() (#248430)
* Fri Feb 23 2007 tiwai@suse.de
- fix mmap syscall on s390x (#248110)
* Thu Feb 15 2007 tiwai@suse.de
- fix a wrong name of store_deref definition (#245544)
* Wed Feb 14 2007 tiwai@suse.de
- fix the handling of function arguments on s390x (#245310)
* Tue Feb  6 2007 tiwai@suse.de
- update to snapshot 20070203, bugfixes including:
  * add missing sockets tapset support (#239346)
  * fix the array membership (#242481)
* Wed Jan 31 2007 tiwai@suse.de
- turn on Autoprov again to fix broken dependency.
* Tue Jan 30 2007 tiwai@suse.de
- update to snapshot 20070120 and elfutils-0.125 to fix major
  bugs (#238710):
  * fixed libdw known bugs in elfutils 0.124
  * add the missing support of tapsetr/errno.stp for s390x
  * fix conditionals in syscall tapset for s390x
  * new macros to safely read/write values from kernel pointers
  * fix the non-standard C behavior to handle NULL in an array
  * fixed support for benchmarking mode with off-line code
  * added support to allow user to use array size declarations
  * reduce number of calls to stp_module_relocate within $tvar
    functions
* Tue Jan  9 2007 tiwai@suse.de
- updated to the recent snapshot version (FATE 301670).
  * fix cache bugs
  * auto-tools fixes
  * probe registartion rework
  * allow negative numeric literals
  * bugfixes/optmizations
- elfutls 1.2.4
  removed codes with problematic license in elfutils (#232894)
* Thu Aug 24 2006 tiwai@suse.de
- update elfutils to 1.2.3, including vmlinux.debuginfo fix.
* Thu Aug 24 2006 tiwai@suse.de
- fix the auto-lookup of vmlinux debuginfo for SUSE systems
- fix the stp compilation with 2.6.18 kernel
* Wed Aug  9 2006 tiwai@suse.de
- updated to latest snapshot (version 0.5.8)
  with elfutils-1.2.2.
* Tue Apr 18 2006 mason@suse.de
- Update to latest snapshot
* Sun Apr  9 2006 mason@suse.de
- created package
